/* TroiaPreview
 * version 0.2 date 2004-09-01
 * Copyright (C) 2003-2004 1stein <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 */

#ifndef INC_Frame
#define INC_Frame

#include "Globals.h"
#include "Pixel.h"

//current frame
extern unsigned char Wall1[PixelZ][PixelX];
extern unsigned char Wall2[PixelZ][PixelY];
extern unsigned char Wall3[PixelZ][PixelX];
extern unsigned char Wall4[PixelZ][PixelY];
extern unsigned char Ceiling[PixelY][PixelX];
extern unsigned char Floor[PixelY][PixelX];

//initialize frame with constant color
void FrameSet( unsigned char Color );

//initialize frame with random data
void FrameRandomize( unsigned char ColorMin, unsigned char ColorMax );

//set a pixel
void FrameSetPixel( tPixel3D Pix, unsigned char Color );

//output text to frame
//top left corner of text is at pixel Pix
//write in direction Dir (encoded as the number on numpad (e.g. 8 for up))
//if a color is not valid (0..255), it will not be drawn
void FrameTextOut( char * pTxt, tPixel3D TopLeft, unsigned char Dir, unsigned short ForeColor, unsigned short BackColor );

#endif //#ifndef INC_Frame