/* TroiaPreview
 * version 0.2 date 2004-09-01
 * Copyright (C) 2003-2004 1stein <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 */

#include "Vector.h"
#include "Globals.h"

//global variables
tVector Pos, Front; //viewer-position and front-direction
bool Back = false; //display background?
bool AntiAlias = false; //use antialiasing?
long CamptsCnt; //list with cam-points
tCampt * pCampts;
double CamptSpeed; //cam-point-speed (in cam-points per second)
double CamptRefTime; //reference-time for cam-point-movement
bool CamMoving; //if cam is moving or not
bool Console = true;

//repair current position and front direction
void RepairPosFront( )
{
	tVector Dir, Top, Left;
	double Angle;

	//do not escape allowed region
	Pos.X = DoubleMinMax( Pos.X, PosMinX, PosMaxX );
	Pos.Y = DoubleMinMax( Pos.Y, PosMinY, PosMaxY );
	Pos.Z = DoubleMinMax( Pos.Z, PosMinZ, PosMaxZ );

	//normalize front vector
	Normalize( &Front );

	//get direction over ground
	Dir = Front;
	Dir.Z = 0;
	Normalize( &Dir );
	//get top and left vectors
	SetVector( &Top, 0.0, 0.0, 1.0 );
	Left = Dir;
	Rotate( &Left, Top, -0.5 * Pi );

	//check angle between front vector and direction
	Angle = VectorAngle( Front, Dir );
	if( Angle > FrontAngleMax ) //angle too big
	{
		if( Front.Z > 0.0 ) //looking up
		{
			//set front vector to maximum up direction
			Front = Dir;
			Rotate( &Front, Left, FrontAngleMax );
		}
		else //looking down
		{
			//set front vector to maximum down direction
			Front = Dir;
			Rotate( &Front, Left, - FrontAngleMax );
		}
	}
}
